diff --git a/src/test/modules/test_checksums/t/007_pgbench_standby.pl b/src/test/modules/test_checksums/t/007_pgbench_standby.pl
new file mode 100644
index 00000000000..b0d40d24005
--- /dev/null
+++ b/src/test/modules/test_checksums/t/007_pgbench_standby.pl
@@ -0,0 +1,400 @@
+
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+# Test suite for testing enabling data checksums in an online cluster,
+# comprising of a primary and a replicated standby, with concurrent activity
+# via pgbench runs
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+# This test suite is expensive, or very expensive, to execute.  There are two
+# PG_TEST_EXTRA options for running it, "checksum" for a pared-down test suite
+# an "checksum_extended" for the full suite.  The full suite can run for hours
+# on slow or constrained systems.
+my $extended = undef;
+if ($ENV{PG_TEST_EXTRA})
+{
+	$extended = 1 if ($ENV{PG_TEST_EXTRA} =~ /\bchecksum_extended\b/);
+	plan skip_all => 'Expensive data checksums test disabled'
+	  unless ($ENV{PG_TEST_EXTRA} =~ /\bchecksum(_extended)?\b/);
+}
+else
+{
+	plan skip_all => 'Expensive data checksums test disabled';
+}
+
+if ($ENV{enable_injection_points} ne 'yes')
+{
+	plan skip_all => 'Injection points not supported by this build';
+}
+
+my $node_primary_slot = 'physical_slot';
+my $node_primary_backup = 'primary_backup';
+my $node_primary;
+my $node_primary_loglocation = 0;
+my $node_standby;
+my $node_standby_loglocation = 0;
+
+# The number of full test iterations which will be performed. The exact number
+# of tests performed and the wall time taken is non-deterministic as the test
+# performs a lot of randomized actions, but 5 iterations will be a long test
+# run regardless.
+my $TEST_ITERATIONS = 5;
+$TEST_ITERATIONS = 1 if ($extended);
+
+# Variables which record the current state of the cluster
+my $data_checksum_state = 'off';
+
+my $pgbench_primary = undef;
+my $pgbench_standby = undef;
+
+# Start a pgbench run in the background against the server specified via the
+# port passed as parameter
+sub background_pgbench
+{
+	my ($port, $standby) = @_;
+	my $pgbench = ($standby ? \$pgbench_standby : \$pgbench_primary);
+
+	# Terminate any currently running pgbench process before continuing
+	$$pgbench->finish if $$pgbench;
+
+	my $clients = 1;
+	my $runtime = 5;
+
+	if ($extended)
+	{
+		# Randomize the number of pgbench clients a bit (range 1-16)
+		$clients = 1 + int(rand(15));
+		$runtime = 600;
+	}
+
+	my @cmd = ('pgbench', '-p', $port, '-T', $runtime, '-c', $clients);
+	# Randomize whether we spawn connections or not
+	push(@cmd, '-C') if ($extended && cointoss());
+	# If we run on a standby it needs to be a read-only benchmark
+	push(@cmd, '-S') if ($standby);
+	# Finally add the database name to use
+	push(@cmd, 'postgres');
+
+	$$pgbench = IPC::Run::start(
+		\@cmd,
+		'<' => '/dev/null',
+		'>' => '/dev/null',
+		'2>' => '/dev/null',
+		IPC::Run::timer($PostgreSQL::Test::Utils::timeout_default));
+}
+
+# Invert the state of data checksums in the cluster, if data checksums are on
+# then disable them and vice versa. Also performs proper validation of the
+# before and after state.
+sub flip_data_checksums
+{
+	# First, make sure the cluster is in the state we expect it to be
+	test_checksum_state($node_primary, $data_checksum_state);
+	test_checksum_state($node_standby, $data_checksum_state);
+
+	if ($data_checksum_state eq 'off')
+	{
+		# Coin-toss to see if we are injecting a retry due to a temptable
+		$node_primary->safe_psql('postgres', 'SELECT dcw_fake_temptable();')
+		  if cointoss();
+
+		# log LSN right before we start changing checksums
+		my $result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN before enabling: " . $result . "\n");
+
+		# Ensure that the primary switches to "inprogress-on"
+		enable_data_checksums($node_primary, wait => 'inprogress-on');
+
+		random_sleep() if ($extended);
+
+		# Wait for checksum enable to be replayed
+		$node_primary->wait_for_catchup($node_standby, 'replay');
+
+		# Ensure that the standby has switched to "inprogress-on" or "on".
+		# Normally it would be "inprogress-on", but it is theoretically
+		# possible for the primary to complete the checksum enabling *and* have
+		# the standby replay that record before we reach the check below.
+		$result = $node_standby->poll_query_until(
+			'postgres',
+			"SELECT setting = 'off' "
+			  . "FROM pg_catalog.pg_settings "
+			  . "WHERE name = 'data_checksums';",
+			'f');
+		is($result, 1,
+			'ensure standby has absorbed the inprogress-on barrier');
+		$result = $node_standby->safe_psql('postgres',
+				"SELECT setting "
+			  . "FROM pg_catalog.pg_settings "
+			  . "WHERE name = 'data_checksums';");
+
+		is(($result eq 'inprogress-on' || $result eq 'on'),
+			1, 'ensure checksums are on, or in progress, on standby_1');
+
+		# Wait for checksums enabled on the primary and standby
+		wait_for_checksum_state($node_primary, 'on');
+
+		# log LSN right after the primary flips checksums to "on"
+		$result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN after enabling: " . $result . "\n");
+
+		random_sleep() if ($extended);
+		wait_for_checksum_state($node_standby, 'on');
+
+		$node_primary->safe_psql('postgres',
+			'SELECT dcw_fake_temptable(false);');
+		$data_checksum_state = 'on';
+	}
+	elsif ($data_checksum_state eq 'on')
+	{
+		random_sleep() if ($extended);
+
+		# log LSN right before we start changing checksums
+		my $result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN before disabling: " . $result . "\n");
+
+		disable_data_checksums($node_primary);
+		$node_primary->wait_for_catchup($node_standby, 'replay');
+
+		# Wait for checksums disabled on the primary and standby
+		wait_for_checksum_state($node_primary, 'off');
+		wait_for_checksum_state($node_standby, 'off');
+
+		# log LSN right after the primary flips checksums to "off"
+		$result =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN after disabling: " . $result . "\n");
+
+		random_sleep() if ($extended);
+		wait_for_checksum_state($node_standby, 'off');
+
+		$data_checksum_state = 'off';
+	}
+	else
+	{
+		# This should only happen due to programmer error when hacking on the
+		# test code, but since that might pass subtly we error out.
+		BAIL_OUT('data_checksum_state variable has invalid state:'
+			  . $data_checksum_state);
+	}
+}
+
+# Create and start a cluster with one primary and one standby node, and ensure
+# they are caught up and in sync.
+$node_primary = PostgreSQL::Test::Cluster->new('pgbench_standby_main');
+$node_primary->init(allows_streaming => 1, no_data_checksums => 1);
+# max_connections need to be bumped in order to accommodate for pgbench clients
+# and log_statement is dialled down since it otherwise will generate enormous
+# amounts of logging. Page verification failures are still logged.
+$node_primary->append_conf(
+	'postgresql.conf',
+	qq[
+max_connections = 30
+log_statement = none
+]);
+$node_primary->start;
+$node_primary->safe_psql('postgres', 'CREATE EXTENSION test_checksums;');
+# Create some content to have un-checksummed data in the cluster
+$node_primary->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1, 100000) AS a;");
+$node_primary->safe_psql('postgres',
+	"SELECT pg_create_physical_replication_slot('$node_primary_slot');");
+$node_primary->backup($node_primary_backup);
+
+$node_standby = PostgreSQL::Test::Cluster->new('pgbench_standby_standby');
+$node_standby->init_from_backup($node_primary, $node_primary_backup,
+	has_streaming => 1);
+$node_standby->append_conf(
+	'postgresql.conf', qq[
+primary_slot_name = '$node_primary_slot'
+]);
+$node_standby->start;
+
+# Initialize pgbench and wait for the objects to be created on the standby
+my $scalefactor = ($extended ? 10 : 1);
+$node_primary->command_ok(
+	[
+		'pgbench', '-p', $node_primary->port, '-i', '-s', $scalefactor, '-q',
+		'postgres'
+	]);
+$node_primary->wait_for_catchup($node_standby, 'replay');
+
+# Start the test suite with pgbench running on all nodes
+background_pgbench($node_standby->port, 1);
+background_pgbench($node_primary->port, 0);
+
+# Main test suite. This loop will start a pgbench run on the cluster and while
+# that's running flip the state of data checksums concurrently. It will then
+# randomly restart the cluster and then check for
+# the desired state.  The idea behind doing things randomly is to stress out
+# any timing related issues by subjecting the cluster for varied workloads.
+# A TODO is to generate a trace such that any test failure can be traced to
+# its order of operations for debugging.
+for (my $i = 0; $i < $TEST_ITERATIONS; $i++)
+{
+	note("iteration ", ($i + 1), " of ", $TEST_ITERATIONS);
+
+	if (!$node_primary->is_alive)
+	{
+		# start, to do recovery, and stop
+		$node_primary->start;
+		$node_primary->stop('fast');
+
+		# Since the log isn't being written to now, parse the log and check
+		# for instances of checksum verification failures.
+		my $log = PostgreSQL::Test::Utils::slurp_file($node_primary->logfile,
+			$node_primary_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed,.+\d$/,
+			"no checksum validation errors in primary log (during WAL recovery)"
+		);
+		$node_primary_loglocation = -s $node_primary->logfile;
+
+		# randomize the WAL size, to trigger checkpoints less/more often
+		my $sb = 32 + int(rand(960));
+		$node_primary->append_conf('postgresql.conf', qq[max_wal_size = $sb]);
+
+		note("changing primary max_wal_size to " . $sb);
+
+		$node_primary->start;
+
+		# Start a pgbench in the background against the primary
+		background_pgbench($node_primary->port, 0);
+	}
+
+	if (!$node_standby->is_alive)
+	{
+		$node_standby->start;
+		$node_standby->stop('fast');
+
+		# Since the log isn't being written to now, parse the log and check
+		# for instances of checksum verification failures.
+		my $log =
+		  PostgreSQL::Test::Utils::slurp_file($node_standby->logfile,
+			$node_standby_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed,.+\d$/,
+			"no checksum validation errors in standby_1 log (during WAL recovery)"
+		);
+		$node_standby_loglocation = -s $node_standby->logfile;
+
+		# randomize the WAL size, to trigger checkpoints less/more often
+		my $sb = 32 + int(rand(960));
+		$node_standby->append_conf('postgresql.conf', qq[max_wal_size = $sb]);
+
+		note("changing standby max_wal_size to " . $sb);
+
+		$node_standby->start;
+
+		# Start a read-only pgbench in the background on the standby
+		background_pgbench($node_standby->port, 1);
+	}
+
+	$node_primary->safe_psql('postgres', "UPDATE t SET a = a + 1;");
+	$node_primary->wait_for_catchup($node_standby, 'write');
+
+	flip_data_checksums();
+	random_sleep() if ($extended);
+	my $result = $node_primary->safe_psql('postgres',
+		"SELECT count(*) FROM t WHERE a > 1");
+	is($result, '100000', 'ensure data pages can be read back on primary');
+	random_sleep();
+
+	# Potentially powercycle the cluster (the nodes independently). A TODO is
+	# to randomly stop the nodes in the opposite order too.
+	if ($extended && cointoss())
+	{
+		$node_primary->stop(stopmode());
+
+		# print the contents of the control file on the primary
+		PostgreSQL::Test::Utils::system_log("pg_controldata",
+			$node_primary->data_dir);
+
+		# slurp the file after shutdown, so that it doesn't interfere with the recovery
+		my $log = PostgreSQL::Test::Utils::slurp_file($node_primary->logfile,
+			$node_primary_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed,.+\d$/,
+			"no checksum validation errors in primary log (outside WAL recovery)"
+		);
+		$node_primary_loglocation = -s $node_primary->logfile;
+	}
+
+	random_sleep() if ($extended);
+
+	if ($extended && cointoss())
+	{
+		$node_standby->stop(stopmode());
+
+		# print the contents of the control file on the standby
+		PostgreSQL::Test::Utils::system_log("pg_controldata",
+			$node_standby->data_dir);
+
+		# slurp the file after shutdown, so that it doesn't interfere with the recovery
+		my $log =
+		  PostgreSQL::Test::Utils::slurp_file($node_standby->logfile,
+			$node_standby_loglocation);
+		unlike(
+			$log,
+			qr/page verification failed,.+\d$/,
+			"no checksum validation errors in standby_1 log (outside WAL recovery)"
+		);
+		$node_standby_loglocation = -s $node_standby->logfile;
+	}
+}
+
+# make sure the nodes are running
+if (!$node_primary->is_alive)
+{
+	$node_primary->start;
+}
+
+if (!$node_standby->is_alive)
+{
+	$node_standby->start;
+}
+
+# Testrun is over, ensure that data reads back as expected and perform a final
+# verification of the data checksum state.
+my $result =
+  $node_primary->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '100000', 'ensure data pages can be read back on primary');
+test_checksum_state($node_primary, $data_checksum_state);
+test_checksum_state($node_standby, $data_checksum_state);
+
+# Perform one final pass over the logs and hunt for unexpected errors
+my $log = PostgreSQL::Test::Utils::slurp_file($node_primary->logfile,
+	$node_primary_loglocation);
+unlike(
+	$log,
+	qr/page verification failed,.+\d$/,
+	"no checksum validation errors in primary log");
+$node_primary_loglocation = -s $node_primary->logfile;
+$log = PostgreSQL::Test::Utils::slurp_file($node_standby->logfile,
+	$node_standby_loglocation);
+unlike(
+	$log,
+	qr/page verification failed,.+\d$/,
+	"no checksum validation errors in standby_1 log");
+$node_standby_loglocation = -s $node_standby->logfile;
+
+$node_standby->teardown_node;
+$node_primary->teardown_node;
+
+done_testing();
diff --git a/src/test/modules/test_checksums/t/008_pitr.pl b/src/test/modules/test_checksums/t/008_pitr.pl
new file mode 100644
index 00000000000..b9b89f414ab
--- /dev/null
+++ b/src/test/modules/test_checksums/t/008_pitr.pl
@@ -0,0 +1,189 @@
+
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+# This test suite is expensive, or very expensive, to execute.  There are two
+# PG_TEST_EXTRA options for running it, "checksum" for a pared-down test suite
+# an "checksum_extended" for the full suite.
+my $extended = undef;
+if ($ENV{PG_TEST_EXTRA})
+{
+	$extended = 1 if ($ENV{PG_TEST_EXTRA} =~ /\bchecksum_extended\b/);
+	plan skip_all => 'Expensive data checksums test disabled'
+	  unless ($ENV{PG_TEST_EXTRA} =~ /\bchecksum(_extended)?\b/);
+}
+else
+{
+	plan skip_all => 'Expensive data checksums test disabled';
+}
+
+
+my $pgbench = undef;
+my $data_checksum_state = 'off';
+
+my $node_primary;
+
+# Invert the state of data checksums in the cluster, if data checksums are on
+# then disable them and vice versa. Also performs proper validation of the
+# before and after state.
+sub flip_data_checksums
+{
+	my $lsn_pre = undef;
+	my $lsn_post = undef;
+
+	# First, make sure the cluster is in the state we expect it to be
+	test_checksum_state($node_primary, $data_checksum_state);
+
+	if ($data_checksum_state eq 'off')
+	{
+		# log LSN right before we start changing checksums
+		$lsn_pre =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN before enabling: " . $lsn_pre . "\n");
+
+		# Wait for checksums enabled on the primary
+		enable_data_checksums($node_primary, wait => 'on');
+
+		# log LSN right after the primary flips checksums to "on"
+		$lsn_post =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+		note("LSN after enabling: " . $lsn_post . "\n");
+
+		$data_checksum_state = 'on';
+	}
+	elsif ($data_checksum_state eq 'on')
+	{
+		# log LSN right before we start changing checksums
+		$lsn_pre =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+
+		disable_data_checksums($node_primary);
+
+		# Wait for checksums disabled on the primary
+		wait_for_checksum_state($node_primary, 'off');
+
+		# log LSN right after the primary flips checksums to "off"
+		$lsn_post =
+		  $node_primary->safe_psql('postgres', "SELECT pg_current_wal_lsn()");
+
+		$data_checksum_state = 'off';
+	}
+	else
+	{
+		# This should only happen due to programmer error when hacking on the
+		# test code, but since that might pass subtly we error out.
+		BAIL_OUT('data_checksum_state variable has invalid state:'
+			  . $data_checksum_state);
+	}
+
+	return ($lsn_pre, $lsn_post);
+}
+# Start a pgbench run in the background against the server specified via the
+# port passed as parameter.
+sub background_rw_pgbench
+{
+	my $port = shift;
+
+	# If a previous pgbench is still running, start by shutting it down.
+	$pgbench->finish if $pgbench;
+
+	# Randomize the number of pgbench clients in extended mode, else 1 client
+	my $clients = ($extended ? 1 + int(rand(15)) : 1);
+	my $runtime = ($extended ? 600 : 5);
+
+	my @cmd = ('pgbench', '-p', $port, '-T', $runtime, '-c', $clients);
+
+	# Randomize whether we spawn connections or not
+	push(@cmd, '-C') if ($extended && cointoss());
+	# Finally add the database name to use
+	push(@cmd, 'postgres');
+
+	$pgbench = IPC::Run::start(
+		\@cmd,
+		'<' => '/dev/null',
+		'>' => '/dev/null',
+		'2>' => '/dev/null',
+		IPC::Run::timer($PostgreSQL::Test::Utils::timeout_default));
+}
+
+# Start a primary node with WAL archiving enabled and with enough connections
+# available to handle pgbench clients.
+$node_primary = PostgreSQL::Test::Cluster->new('pitr_main');
+$node_primary->init(
+	has_archiving => 1,
+	allows_streaming => 1,
+	no_data_checksums => 1);
+$node_primary->append_conf(
+	'postgresql.conf',
+	qq[
+max_connections = 100
+log_statement = none
+]);
+$node_primary->start;
+
+# Prime the cluster with a bit of known data which we can read back to check
+# for data consistency as well as page verification faults in the logfile.
+$node_primary->safe_psql('postgres',
+	'CREATE TABLE t AS SELECT generate_series(1, 100000) AS a;');
+# Initialize and start pgbench in read/write mode against the cluster
+my $scalefactor = ($extended ? 10 : 1);
+$node_primary->command_ok(
+	[
+		'pgbench', '-p', $node_primary->port, '-i', '-s', $scalefactor, '-q',
+		'postgres'
+	]);
+background_rw_pgbench($node_primary->port);
+
+# Take a backup to use for PITR
+my $backup_name = 'my_backup';
+$node_primary->backup($backup_name);
+
+my ($pre_lsn, $post_lsn) = flip_data_checksums();
+
+$node_primary->safe_psql('postgres', "UPDATE t SET a = a + 1;");
+$node_primary->safe_psql('postgres', "SELECT pg_create_restore_point('a');");
+$node_primary->safe_psql('postgres', "UPDATE t SET a = a + 1;");
+$node_primary->stop('immediate');
+
+my $node_pitr = PostgreSQL::Test::Cluster->new('pitr_backup');
+$node_pitr->init_from_backup(
+	$node_primary, $backup_name,
+	standby => 0,
+	has_restoring => 1);
+$node_pitr->append_conf(
+	'postgresql.conf', qq{
+recovery_target_lsn = '$post_lsn'
+recovery_target_action = 'promote'
+recovery_target_inclusive = on
+});
+
+$node_pitr->start;
+
+$node_pitr->poll_query_until('postgres', "SELECT pg_is_in_recovery() = 'f';")
+  or die "Timed out while waiting for PITR promotion";
+
+test_checksum_state($node_pitr, $data_checksum_state);
+my $result =
+  $node_pitr->safe_psql('postgres', "SELECT count(*) FROM t WHERE a > 1");
+is($result, '99999', 'ensure data pages can be read back on primary');
+
+$node_pitr->stop;
+
+my $log = PostgreSQL::Test::Utils::slurp_file($node_pitr->logfile, 0);
+unlike(
+	$log,
+	qr/page verification failed,.+\d$/,
+	"no checksum validation errors in pitr log");
+
+done_testing();
diff --git a/src/test/modules/test_checksums/t/009_fpi.pl b/src/test/modules/test_checksums/t/009_fpi.pl
new file mode 100644
index 00000000000..a1cea91f787
--- /dev/null
+++ b/src/test/modules/test_checksums/t/009_fpi.pl
@@ -0,0 +1,64 @@
+
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+use strict;
+use warnings FATAL => 'all';
+
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+use FindBin;
+use lib $FindBin::RealBin;
+
+use DataChecksums::Utils;
+
+# Create and start a cluster with one node
+my $node = PostgreSQL::Test::Cluster->new('fpi_node');
+$node->init(allows_streaming => 1, no_data_checksums => 1);
+# max_connections need to be bumped in order to accommodate for pgbench clients
+# and log_statement is dialled down since it otherwise will generate enormous
+# amounts of logging. Page verification failures are still logged.
+$node->append_conf(
+	'postgresql.conf',
+	qq[
+max_connections = 100
+log_statement = none
+]);
+$node->start;
+$node->safe_psql('postgres', 'CREATE EXTENSION test_checksums;');
+# Create some content to have un-checksummed data in the cluster
+$node->safe_psql('postgres',
+	"CREATE TABLE t AS SELECT generate_series(1, 1000000) AS a;");
+
+# Enable data checksums and wait for the state transition to 'on'
+enable_data_checksums($node, wait => 'on');
+
+$node->safe_psql('postgres', 'UPDATE t SET a = a + 1;');
+
+disable_data_checksums($node, wait => 1);
+
+$node->append_conf('postgresql.conf', 'full_page_writes = off');
+$node->restart;
+test_checksum_state($node, 'off');
+
+$node->safe_psql('postgres', 'UPDATE t SET a = a + 1;');
+$node->safe_psql('postgres', 'DELETE FROM t WHERE a < 10000;');
+
+$node->adjust_conf('postgresql.conf', 'full_page_writes', 'on');
+$node->restart;
+test_checksum_state($node, 'off');
+
+enable_data_checksums($node, wait => 'on');
+
+my $result = $node->safe_psql('postgres', 'SELECT count(*) FROM t;');
+is($result, '990003', 'Reading back all data from table t');
+
+$node->stop;
+my $log = PostgreSQL::Test::Utils::slurp_file($node->logfile, 0);
+unlike(
+	$log,
+	qr/page verification failed,.+\d$/,
+	"no checksum validation errors in server log");
+
+done_testing();
diff --git a/src/test/modules/test_checksums/t/DataChecksums/Utils.pm b/src/test/modules/test_checksums/t/DataChecksums/Utils.pm
new file mode 100644
index 00000000000..9a2269e8a92
--- /dev/null
+++ b/src/test/modules/test_checksums/t/DataChecksums/Utils.pm
@@ -0,0 +1,262 @@
+
+# Copyright (c) 2026, PostgreSQL Global Development Group
+
+=pod
+
+=head1 NAME
+
+DataChecksums::Utils - Utility functions for testing data checksums in a running cluster
+
+=head1 SYNOPSIS
+
+  use PostgreSQL::Test::Cluster;
+  use DataChecksums::Utils qw( .. );
+
+  # Create, and start, a new cluster
+  my $node = PostgreSQL::Test::Cluster->new('primary');
+  $node->init;
+  $node->start;
+
+  test_checksum_state($node, 'off');
+
+  enable_data_checksums($node);
+
+  wait_for_checksum_state($node, 'on');
+
+
+=cut
+
+package DataChecksums::Utils;
+
+use strict;
+use warnings FATAL => 'all';
+use Exporter 'import';
+use PostgreSQL::Test::Cluster;
+use PostgreSQL::Test::Utils;
+use Test::More;
+
+our @EXPORT = qw(
+  cointoss
+  disable_data_checksums
+  enable_data_checksums
+  random_sleep
+  stopmode
+  test_checksum_state
+  wait_for_checksum_state
+  wait_for_cluster_crash
+);
+
+=pod
+
+=head1 METHODS
+
+=over
+
+=item test_checksum_state(node, state)
+
+Test that the current value of the data checksum GUC in the server running
+at B<node> matches B<state>.  If the values differ, a test failure is logged.
+Returns True if the values match, otherwise False.
+
+=cut
+
+sub test_checksum_state
+{
+	my ($postgresnode, $state) = @_;
+
+	my $result = $postgresnode->safe_psql('postgres',
+		"SELECT setting FROM pg_catalog.pg_settings WHERE name = 'data_checksums';"
+	);
+	is($result, $state, 'ensure checksums are set to ' . $state);
+	return $result eq $state;
+}
+
+=item wait_for_checksum_state(node, state)
+
+Test the value of the data checksum GUC in the server running at B<node>
+repeatedly until it matches B<state> or times out.  Processing will run for
+$PostgreSQL::Test::Utils::timeout_default seconds before timing out.  If the
+values differ when the process times out, False is returned and a test failure
+is logged, otherwise True.
+
+=cut
+
+sub wait_for_checksum_state
+{
+	my ($postgresnode, $state) = @_;
+
+	my $res = $postgresnode->poll_query_until(
+		'postgres',
+		"SELECT setting FROM pg_catalog.pg_settings WHERE name = 'data_checksums';",
+		$state);
+	is($res, 1, 'ensure data checksums are transitioned to ' . $state);
+	return $res == 1;
+}
+
+=item wait_for_cluster_crash(node, params)
+
+Repeatedly test if the cluster running at B<node> responds to connections
+and return when it no longer does so, or when it times out.  Processing will
+run for $PostgreSQL::Test::Utils::timeout_default seconds unless a timeout
+value is specified as a parameter.  Returns True if the cluster crashed, else
+False if the process timed out.
+
+=over
+
+=item timeout
+
+Approximate number of seconds to wait for cluster to crash, default is
+$PostgreSQL::Test::Utils::timeout_default.  There are no real-time guarantees
+that the total process time won't exceed the timeout.
+
+=back
+
+=cut
+
+sub wait_for_cluster_crash
+{
+	my $postgresnode = shift;
+	my %params = @_;
+	my $crash = 0;
+
+	$params{timeout} = $PostgreSQL::Test::Utils::timeout_default
+	  unless (defined($params{timeout}));
+
+	for (my $naps = 0; $naps < $params{timeout}; $naps++)
+	{
+		if (!$postgresnode->is_alive)
+		{
+			$crash = 1;
+			last;
+		}
+		sleep(1);
+	}
+
+	return $crash == 1;
+}
+
+=item enable_data_checksums($node, %params)
+
+Function for enabling data checksums in the cluster running at B<node>.
+
+=over
+
+=item cost_delay
+
+The B<cost_delay> to use when enabling data checksums, default is 0.
+
+=item cost_limit
+
+The B<cost_limit> to use when enabling data checksums, default is 100.
+
+=item wait
+
+If defined, the function will wait for the state defined in this parameter,
+waiting timing out, before returning.  The function will wait for
+$PostgreSQL::Test::Utils::timeout_default seconds before timing out.
+
+=back
+
+=cut
+
+sub enable_data_checksums
+{
+	my $postgresnode = shift;
+	my %params = @_;
+
+	# Set sane defaults for the parameters
+	$params{cost_delay} = 0 unless (defined($params{cost_delay}));
+	$params{cost_limit} = 100 unless (defined($params{cost_limit}));
+
+	my $query = <<'EOQ';
+SELECT pg_enable_data_checksums(%s, %s);
+EOQ
+
+	$postgresnode->safe_psql('postgres',
+		sprintf($query, $params{cost_delay}, $params{cost_limit}));
+
+	wait_for_checksum_state($postgresnode, $params{wait})
+	  if (defined($params{wait}));
+}
+
+=item disable_data_checksums($node, %params)
+
+Function for disabling data checksums in the cluster running at B<node>.
+
+=over
+
+=item wait
+
+If defined, the function will wait for the state to turn to B<off>, or
+waiting timing out, before returning.  The function will wait for
+$PostgreSQL::Test::Utils::timeout_default seconds before timing out.
+Unlike in C<enable_data_checksums> the value of the parameter is discarded.
+
+=back
+
+=cut
+
+sub disable_data_checksums
+{
+	my $postgresnode = shift;
+	my %params = @_;
+
+	$postgresnode->safe_psql('postgres',
+		'SELECT pg_disable_data_checksums();');
+
+	wait_for_checksum_state($postgresnode, 'off') if (defined($params{wait}));
+}
+
+=item cointoss
+
+Helper for retrieving a binary value with random distribution for deciding
+whether to turn things off during testing.
+
+=back
+
+=cut
+
+sub cointoss
+{
+	return int(rand() < 0.5);
+}
+
+=item random_sleep(max)
+
+Helper for injecting random sleeps here and there in the testrun. The sleep
+duration will be in the range (0,B<max>), but won't be predictable in order to
+avoid sleep patterns that manage to avoid race conditions and timing bugs.
+The default B<max> is 3 seconds.
+
+=back
+
+=cut
+
+sub random_sleep
+{
+	my $max = shift;
+	return if (defined($max) && ($max == 0));
+	sleep(int(rand(defined($max) ? $max : 3))) if cointoss;
+}
+
+=item stopmode
+
+Small helper function for randomly selecting a valid stopmode.
+
+=back
+
+=cut
+
+sub stopmode
+{
+	return 'immediate' if (cointoss);
+	return 'fast';
+}
+
+=pod
+
+=back
+
+=cut
+
+1;
diff --git a/src/test/modules/test_checksums/test_checksums--1.0.sql b/src/test/modules/test_checksums/test_checksums--1.0.sql
new file mode 100644
index 00000000000..90642d247fa
--- /dev/null
+++ b/src/test/modules/test_checksums/test_checksums--1.0.sql
@@ -0,0 +1,24 @@
+/* src/test/modules/test_checksums/test_checksums--1.0.sql */
+
+-- complain if script is sourced in psql, rather than via CREATE EXTENSION
+\echo Use "CREATE EXTENSION test_checksums" to load this file. \quit
+
+CREATE FUNCTION dcw_inject_delay_barrier(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_inject_launcher_delay(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_inject_startup_delay(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_inject_fail_database(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
+
+CREATE FUNCTION dcw_fake_temptable(attach boolean DEFAULT true)
+	RETURNS pg_catalog.void
+	AS 'MODULE_PATHNAME' LANGUAGE C;
